#include "StdAfx.h"
#include "ChangeNoticeController.h"
#include "ServerAddrConfig.h"

#include <afxstr.h>

ChangeNoticeController::ChangeNoticeController(void)
{
	m_strPrevLastModifyTime = _T("");
    m_nChangeNoticeSeq = 0;
    m_ChangeTypeCode = CHANGETYPE_CHC01; //0;
    bExposeLogin = FALSE;
    bExposePopup = FALSE;
    bExposeCycleLogin = FALSE;
    bExposeCycleDay = FALSE;
    bExposeCycleMin = FALSE;
}

ChangeNoticeController::~ChangeNoticeController(void)
{
}


void ChangeNoticeController::SetNoticeData( const ChangeNoticeData &changeNotice )
{
	SetChangeNoticeSeq(changeNotice.nChangeNoticeSeq);
	m_strCurrentLastModifyTime = changeNotice.strLastModifyYMDT.c_str();
	SetCheckReasonKR(changeNotice.strChekReason.c_str());
	SetCheckReasonEN(changeNotice.strChekReasonEn.c_str());
	SetCheckReasonJP(changeNotice.strChekReasonJp.c_str());
	SetCheckReasonCN(changeNotice.strChekReasonCn.c_str());
	SetCheckReasonTW(changeNotice.strChekReasonTw.c_str());

	CString strChangeTypeCode(changeNotice.strChangeTypeCode.c_str());
	if (strChangeTypeCode == L"CHC01")
	{
		SetChangeTypeCode(CHANGETYPE_CHC01);
	}
	else if (strChangeTypeCode == L"CHC02")
	{
		SetChangeTypeCode(CHANGETYPE_CHC02);
	}
	else if(strChangeTypeCode == L"CHC03")
	{
		SetChangeTypeCode(CHANGETYPE_CHC03);
	}
	else
	{
	}
	


	std::vector<WSTRING>::const_iterator itr = changeNotice.vecExposureCycleCd.begin();
	for(;itr != changeNotice.vecExposureCycleCd.end();++itr)
	{
		WSTRING str = *itr;
		CString strExposesureCycle(str.c_str());
		if (strExposesureCycle== L"EXC01") // α(αν) ش
			bExposeCycleLogin = TRUE;
		else if (strExposesureCycle == L"EXC02") //1 1ȸ
			bExposeCycleDay = TRUE;
		else if (strExposesureCycle == L"EXC03") //  10 1ȸ
			bExposeCycleMin = TRUE;
	}


	SetExposeTime(changeNotice.strExposureHM.c_str());

	std::vector<WSTRING>::const_iterator itrExposeLocation = changeNotice.vecExposureLocation.begin();
	for(;itrExposeLocation != changeNotice.vecExposureLocation.end();++itrExposeLocation)
	{
		WSTRING str = *itrExposeLocation;
		CString strExposeLocation(str.c_str());
		if (strExposeLocation == _T("ELC01")) // α(αν) ش
			bExposeLogin = TRUE;
		else if (strExposeLocation == L"ELC02") //˾ ش
			bExposePopup = TRUE;
	}

	SetStartTime(_ttol(changeNotice.strStartYMDT.c_str()));
	SetEndTime(_ttol(changeNotice.strEndYMDT.c_str()));
	SetCheckStartYMDT(_ttol(changeNotice.strCheckStartYMDT.c_str()));
	SetCheckEndYMDT(_ttol(changeNotice.strCheckEndYMDT.c_str()));
}

void ChangeNoticeController::SetChangeTypeCode( ChangeType typeCode )
{
	if (typeCode == CHANGETYPE_CHC01)//
	{
		m_ChangeTypeCode = CHANGETYPE_CHC01;
		m_strChangeTypeTitle = LoadStringFromResource(IDS_STRING616);
	}
	else if(typeCode == CHANGETYPE_CHC02)//ӽ
	{
		m_ChangeTypeCode = CHANGETYPE_CHC02;
		m_strChangeTypeTitle = LoadStringFromResource(IDS_STRING617);
	}
	else if(typeCode == CHANGETYPE_CHC03)//
	{
		m_ChangeTypeCode = CHANGETYPE_CHC03;
		m_strChangeTypeTitle = LoadStringFromResource(IDS_STRING618);
	}
}

void ChangeNoticeController::SetExposeTime( CString strHM )
{
	CTime curTime = CTimeConversion::GetKoreaTime();
	CString strExposeTime;
	strExposeTime.Format(_T("%04d-%02d-%02d %s:00"), curTime.GetYear(), curTime.GetMonth(), curTime.GetDay(), strHM);

	int nYear= _ttoi(strExposeTime.Left(4));
	int nMon = _ttoi(strExposeTime.Mid(5,2));
	int nDay = _ttoi(strExposeTime.Mid(8,2));
	int nHour= _ttoi(strExposeTime.Mid(11,2));
	int nMin = _ttoi(strExposeTime.Mid(14,2));
	int nSec = _ttoi(strExposeTime.Mid(17,2));
	CTime ExposeTime(nYear, nMon, nDay, nHour, nMin, nSec);
	
	m_timeExposureHM = ExposeTime;
}

void ChangeNoticeController::SetStartTime( long ltime )
{
	CTime time(ltime);
	m_timeStartYMDT = time;
}

void ChangeNoticeController::SetEndTime( long ltime )
{
	CTime time(ltime);
	m_timeEndYMDT = time;
}

void ChangeNoticeController::SetCheckStartYMDT( long ltime )
{
	CTime time(ltime);
	m_timeCheckStartYMDT = time;
}

void ChangeNoticeController::SetCheckEndYMDT( long ltime )
{
	CTime time(ltime);
	m_timeCheckEndYMDT = time;
}



BOOL ChangeNoticeController::IsExposeLogin()
{	
	return bExposeLogin;
}

void ChangeNoticeController::Clear()
{
	bExposeLogin = FALSE;
	bExposePopup = FALSE;
	bExposeCycleLogin = FALSE;
	bExposeCycleDay = FALSE;
	bExposeCycleMin = FALSE;
	m_strChekReason = _T("");					//
	m_strChekReasonEn = _T("");					//()
	m_strChekReasonJp = _T("");					//(Ͼ)
	m_strChekReasonCn = _T("");					//(߱ü)
	m_strChekReasonTw = _T("");					//(߱ü)
	vecExposureCycleCd.clear();	//ֱŸڵ 
	vecExposureLocation.clear();	//ġ  
}


BOOL ChangeNoticeController::IsLoginDlgShow()
{

	CTime curTime = CTimeConversion::GetKoreaTime();

	TRACE(L"%d.%d.%d. %d:%d", curTime.GetYear(),curTime.GetMonth(),curTime.GetDay(),
		curTime.GetHour(),curTime.GetMinute());
	if (
		curTime >= m_timeStartYMDT &&
		curTime <= m_timeEndYMDT && bExposeLogin)
	{
		return TRUE;
	}
	return FALSE;
}

BOOL ChangeNoticeController::IsExposeDomain()
{
    BOOL bRet = FALSE;
    switch (CServerAddrConfig::Instance().GetServerType())
    {
    case SERVER_TYPE_REAL:
        bRet = FALSE;
        break;
    default:
        bRet = TRUE;
        break;
    }
    return bRet;

    //   üũ Ѵ.
//#if defined(_SERVER_VERSION_REAL)
//	//std::vector<WSTRING>::const_iterator itr = m_vecCoList.begin();
//	//for(;itr != m_vecCoList.end();++itr)
//	//{
//	//	WSTRING str = *itr;
//	//	CString strExposeDomain(str.c_str());
//	//	if (strExposeDomain == g_stNtalkInfo.strCorp) // α(αν) ش
//	//		return TRUE;
//	//}
//	return FALSE;
//#else
//	//, ¡    ش.
//	return TRUE;
//#endif
}


BOOL ChangeNoticeController::IsNoticeDlgLoginShow()
{
	CTime curTime = CTimeConversion::GetKoreaTime();
	if (curTime >= m_timeStartYMDT &&
		curTime <= m_timeEndYMDT && bExposeCycleLogin)
	{
		return TRUE;
	}
	return FALSE;
}


